#include "types.t"
#include "defines.t"

// CLASS CATALOG

class catalog_type

{
  area "sys";

  inherits generic_acl;

#include "check_acl.t"

  container_class '';
  container_column_name '';

 // PROPERTIES

#include "generic_acl_props.t"

  prop parent_class
  {
    type CO_STRING;
    default "''";
    params '';
    representant 0;
    foreign 'meta_class';
    foreign_prop 'class_name';
    position 200;
  };

  prop class_name
  {
    type CO_STRING;
    default "''";
    params '';
    representant 100;
    foreign 'meta_class';
    foreign_prop 'class_name';
    position 200;
  };

  prop create_params
  {
    type CO_STRING;
    default "''";
    params '';
    representant 0;
    foreign '';
    foreign_prop '';
    position 300;
  };

  prop container
  {
    type CO_INTEGER;
    default 0;
    params '';
    representant 0;
    foreign '';
    foreign_prop '';
    position 300;
  };

  method getIdForClasses
  {
   id_permission __PERMISSION_SELECT;
   sec_type __METHOD_SEC_TYPE_CLASS;

   doc "This method retrieves id (CO_INTEGER) of given property for given catalog type. Catalog type is identified using par_area, parent_class and class_name. Returns 0 if not found."
   {
       pl "Ta metoda zwraca id (jako CO_INTEGER) typu katalogowego identyfikowanego przez par_area, class_name i parent_class. Zwraca 0 jeli brak takiego typu.";
   };
   
    __PARAMS_HEADER_WITH_CALLBACK

    param parent_class 
    {
      type CO_STRING;
      doc "Name of the class of the catalog object."
      {
         pl "Nazwa klasy obiektu katalogowego, wskazujcego na obiekt klasy class_name";
      };
    };

    param class_name 
    {
      type CO_STRING;
      doc "Name of the class the catalog object points to."
      {
         pl "Nazwa klasy obiektu, na ktry wskazuje obiekt katalogowy";
      };
    };

    declare language_c
    {
      C
      %%
         int id_type = 0;
      %%
      ;
    };
    
    body language_c
      {
         C
	 %%
		__SQL_GET_INTEGER(id_type, "SELECT id FROM co_%s_%s WHERE parent_class='%s' AND class_name='%s'", par_area, par_class, parent_class, class_name)
		__CREATE_JS_FROM_INTEGER(id_type)
		__RETURN_INTEGER(id_type)
	 %%
	 ;
      };  
								    
  };


};

//END OF CLASS CATALOG
