
#include "httpd.h"
#include "co_lib.h"
#include "co_defines.h"
#include "co_defines_calls.h"

#include "co_generic_association.h"

#undef  __METHOD__
#define __METHOD__ "coj_generic_association"

void *
coj_generic_association_new_param( co_context *ctx, const char* method_name)
{
    pool *p = ctx->request->pool;

    cou_logError( ctx, CO_LOG_DEBUG, "coj_generic_association_new_param: called for %s", method_name);
     
    if (strcmp(method_name, "showFormAssociation")==0) 
    {
        __PARAM_STRUCT_CREATE_showFormAssociation(ret_showFormAssociation);
        cou_logError( ctx, CO_LOG_DEBUG, "allocating param struct for showFormAssociation");
        return (void *)ret_showFormAssociation;
    }
      
    if (strcmp(method_name, "showFormMenu")==0) 
    {
        __PARAM_STRUCT_CREATE_showFormMenu(ret_showFormMenu);
        cou_logError( ctx, CO_LOG_DEBUG, "allocating param struct for showFormMenu");
        return (void *)ret_showFormMenu;
    }
      
    if (strcmp(method_name, "insertAssociations")==0) 
    {
        __PARAM_STRUCT_CREATE_insertAssociations(ret_insertAssociations);
        cou_logError( ctx, CO_LOG_DEBUG, "allocating param struct for insertAssociations");
        return (void *)ret_insertAssociations;
    }
    
    return NULL;
}

#undef  __METHOD__
#define __METHOD__ "coj_generic_association_set_param"

int
coj_generic_association_set_param( co_context *ctx, void *ph,
        const char* method_name, const char *param_name, void *param_value)
{
    int err=0;
    cou_logError( ctx, CO_LOG_DEBUG, "coj_generic_association_set_param: called");
  
    if (strcmp(method_name, "showFormAssociation")==0) {

	co_typein_showFormAssociation *p;
        p = (co_typein_showFormAssociation*)ph;
    
        if (strcmp(param_name, "par_area")==0) {  __PARAM_STRUCT_SET((const char*)(param_value), p , par_area) 

          return err;
	} 
        if (strcmp(param_name, "par_class")==0) {  __PARAM_STRUCT_SET((const char*)(param_value), p , par_class) 

          return err;
	} 
        if (strcmp(param_name, "par_id")==0) {  __PARAM_STRUCT_SET(*(int*)(param_value), p , par_id) 

          return err;
	} 
        if (strcmp(param_name, "column_first_class")==0) {  __PARAM_STRUCT_SET((const char*)(param_value), p , column_first_class) 

          return err;
	} 
        if (strcmp(param_name, "report_first_class")==0) {  __PARAM_STRUCT_SET((const char*)(param_value), p , report_first_class) 

          return err;
	} 
        if (strcmp(param_name, "column_second_class")==0) {  __PARAM_STRUCT_SET((const char*)(param_value), p , column_second_class) 

          return err;
	} 
        if (strcmp(param_name, "report_second_class")==0) {  __PARAM_STRUCT_SET((const char*)(param_value), p , report_second_class) 

          return err;
	} }  
    if (strcmp(method_name, "showFormMenu")==0) {

	co_typein_showFormMenu *p;
        p = (co_typein_showFormMenu*)ph;
    
        if (strcmp(param_name, "par_area")==0) {  __PARAM_STRUCT_SET((const char*)(param_value), p , par_area) 

          return err;
	} 
        if (strcmp(param_name, "par_class")==0) {  __PARAM_STRUCT_SET((const char*)(param_value), p , par_class) 

          return err;
	} 
        if (strcmp(param_name, "par_id")==0) {  __PARAM_STRUCT_SET(*(int*)(param_value), p , par_id) 

          return err;
	} 
        if (strcmp(param_name, "menu_name")==0) {  __PARAM_STRUCT_SET((const char*)(param_value), p , menu_name) 

          return err;
	} 
        if (strcmp(param_name, "menu_type")==0) {  __PARAM_STRUCT_SET((const char*)(param_value), p , menu_type) 

          return err;
	} }  
    if (strcmp(method_name, "insertAssociations")==0) {

	co_typein_insertAssociations *p;
        p = (co_typein_insertAssociations*)ph;
    
        if (strcmp(param_name, "par_area")==0) {  __PARAM_STRUCT_SET((const char*)(param_value), p , par_area) 

          return err;
	} 
        if (strcmp(param_name, "par_class")==0) {  __PARAM_STRUCT_SET((const char*)(param_value), p , par_class) 

          return err;
	} 
        if (strcmp(param_name, "par_id")==0) {  __PARAM_STRUCT_SET(*(int*)(param_value), p , par_id) 

          return err;
	} 
        if (strcmp(param_name, "callback")==0) {  __PARAM_STRUCT_SET((const char*)(param_value), p , callback) 

          return err;
	} 
        if (strcmp(param_name, "ids_first_class")==0) {  __PARAM_STRUCT_SET((co_array_of_pointers *)(param_value), p , ids_first_class) 

          return err;
	} 
        if (strcmp(param_name, "prop_first_class")==0) {  __PARAM_STRUCT_SET((const char*)(param_value), p , prop_first_class) 

          return err;
	} 
        if (strcmp(param_name, "ids_second_class")==0) {  __PARAM_STRUCT_SET((co_array_of_pointers *)(param_value), p , ids_second_class) 

          return err;
	} 
        if (strcmp(param_name, "prop_second_class")==0) {  __PARAM_STRUCT_SET((const char*)(param_value), p , prop_second_class) 

          return err;
	} }
    return -1; /* param not found */
} 

#undef  __METHOD__
#define __METHOD__ "coj_generic_association_get_param"

void *
coj_generic_association_get_param( co_context *ctx, void *ph,
        const char* method_name, const char *param_name, co_value_type *ptr_param_type)
{
    int err=0;
    cou_logError( ctx, CO_LOG_DEBUG, "coj_generic_association_get_param: called");
  
    if (strcmp(method_name, "showFormAssociation")==0) {

	co_typein_showFormAssociation *p;
        p = (co_typein_showFormAssociation*)ph;
    
        if (strcmp(param_name, "par_area")==0) {
	    *ptr_param_type = CO_STRING;
            return &(p->values->par_area);
	}
        if (strcmp(param_name, "par_class")==0) {
	    *ptr_param_type = CO_STRING;
            return &(p->values->par_class);
	}
        if (strcmp(param_name, "par_id")==0) {
	    *ptr_param_type = CO_INTEGER;
            return &(p->values->par_id);
	}
        if (strcmp(param_name, "column_first_class")==0) {
	    *ptr_param_type = CO_STRING;
            return &(p->values->column_first_class);
	}
        if (strcmp(param_name, "report_first_class")==0) {
	    *ptr_param_type = CO_STRING;
            return &(p->values->report_first_class);
	}
        if (strcmp(param_name, "column_second_class")==0) {
	    *ptr_param_type = CO_STRING;
            return &(p->values->column_second_class);
	}
        if (strcmp(param_name, "report_second_class")==0) {
	    *ptr_param_type = CO_STRING;
            return &(p->values->report_second_class);
	}} 
  
    if (strcmp(method_name, "showFormMenu")==0) {

	co_typein_showFormMenu *p;
        p = (co_typein_showFormMenu*)ph;
    
        if (strcmp(param_name, "par_area")==0) {
	    *ptr_param_type = CO_STRING;
            return &(p->values->par_area);
	}
        if (strcmp(param_name, "par_class")==0) {
	    *ptr_param_type = CO_STRING;
            return &(p->values->par_class);
	}
        if (strcmp(param_name, "par_id")==0) {
	    *ptr_param_type = CO_INTEGER;
            return &(p->values->par_id);
	}
        if (strcmp(param_name, "menu_name")==0) {
	    *ptr_param_type = CO_STRING;
            return &(p->values->menu_name);
	}
        if (strcmp(param_name, "menu_type")==0) {
	    *ptr_param_type = CO_STRING;
            return &(p->values->menu_type);
	}} 
  
    if (strcmp(method_name, "insertAssociations")==0) {

	co_typein_insertAssociations *p;
        p = (co_typein_insertAssociations*)ph;
    
        if (strcmp(param_name, "par_area")==0) {
	    *ptr_param_type = CO_STRING;
            return &(p->values->par_area);
	}
        if (strcmp(param_name, "par_class")==0) {
	    *ptr_param_type = CO_STRING;
            return &(p->values->par_class);
	}
        if (strcmp(param_name, "par_id")==0) {
	    *ptr_param_type = CO_INTEGER;
            return &(p->values->par_id);
	}
        if (strcmp(param_name, "callback")==0) {
	    *ptr_param_type = CO_STRING;
            return &(p->values->callback);
	}
        if (strcmp(param_name, "ids_first_class")==0) {
	    *ptr_param_type = CO_ARRAY_OF_STRINGS;
            return &(p->values->ids_first_class);
	}
        if (strcmp(param_name, "prop_first_class")==0) {
	    *ptr_param_type = CO_STRING;
            return &(p->values->prop_first_class);
	}
        if (strcmp(param_name, "ids_second_class")==0) {
	    *ptr_param_type = CO_ARRAY_OF_STRINGS;
            return &(p->values->ids_second_class);
	}
        if (strcmp(param_name, "prop_second_class")==0) {
	    *ptr_param_type = CO_STRING;
            return &(p->values->prop_second_class);
	}} 

    *ptr_param_type = CO_NO_TYPE;
    return NULL; /* param not found */
}
