 
type CO_INDEX
 {
   c_type int;
   sql_type int;
   js_type Number;
   pointer 0;
   is_array 0;
 };
	      
type CO_INTEGER
 {
   c_type int;
   sql_type int;
   js_type Number;
   pointer 0;
   is_array 0;
 };
	      
type CO_STRING
 {
   c_type "const char*";
   sql_type text;
   js_type String;
   pointer 1;
   is_array 0;
 };
 
type CO_POINTER
 {
   c_type "void *";
   sql_type ****WRONG****;
   js_type ****WRONG****;
   pointer 1;
   is_array 0;
 };
 
type CO_ARRAY_OF_STRINGS
 {
   c_type "co_array_of_pointers *";
   sql_type ****WRONG****;
   js_type '';
   pointer 1;
   is_array 1;
 };    
			  
type CO_STRING_SQL_VALUE
 {
   c_type "const char*";
   sql_type ****WRONG****;    
   js_type String;
   pointer 1;
   is_array 0;
 };

type CO_BOOL
 {
   c_type bool;
   sql_type bool;
   js_type Boolean;
   pointer 0;
   is_array 0;
 };

type CO_DATE
 {
  c_type "const char*";
  sql_type date;
  js_type Date;
  pointer 1;
  is_array 0;
 };

type CO_TIME
 {
  c_type "const char*";
  sql_type time;
  js_type Date;
  pointer 1;
  is_array 0;
 };
 
type CO_TIMESTAMP
 {
  c_type "const char*";
  sql_type timestamp;
  js_type Date;
  pointer 1;
  is_array 0;
 };

type CO_REAL
 {
  c_type float; 
  sql_type float4; 
  js_type Number; 
  pointer 0;
  is_array 0;
 };

type CO_NUMERIC
 {
  c_type float; 
  sql_type numeric; 
  js_type Number; 
  pointer 0;
  is_array 0;
 };

type CO_MONEY
 {
  c_type float; 
  sql_type 'numeric(30,2)';
  js_type Number; 
  pointer 0;
  is_array 0;
 };


//#define __PARAMS_HEADER_2D param par_area {type CO_STRING; optional 1; default "par_area=cnx->par_area;";}; param par_class {type CO_STRING; optional 1; default "par_class=cnx->par_class;";}; param par_id1 { type CO_INTEGER; }; param par_id2 { type CO_INTEGER; };




//#define __PARAMS_HEADER_2D_WITH_CALLBACK __PARAMS_HEADER_2D param callback {type CO_STRING; optional 1; default "callback=ap_psprintf(p,\"alert(\");";};
























class generic_association
{
   area "sys";

   container_class '';
   container_column_name '';   


 f_check_acl_class 
    %%
      @ "SELECT 1 FROM co_sys_acl_class WHERE area = \\'$name_area\\' AND class_name = \\'$name_class\\' AND id_permission = \$1 AND id_role = \$2 ; \n"
    %%
    ;
 f_check_acl 
    %%
      @ "SELECT 1 FROM co_sys_acl WHERE area = \\'$name_area\\' AND class_name = \\'$name_class\\' AND id_object = \$1 AND id_permission = \$2 AND id_role = \$3 ;" 
    %% 
    ;



    
   inherits generic_acl;

   uses "generic";

sequence sqid; 
index inid 
{ 
 unique 1; 
 column id; 
}; 

prop id 
{ 
  type CO_INTEGER; 
  default SEQUENCE { sq_name sqid; }; 
  params "READONLY=1;HIDDEN=1";
  representant 0;
  foreign '';
  foreign_prop '';
  position 0;
};

prop version
{
  type CO_INTEGER;
  default 0;
  params "READONLY=1;HIDDEN=1";
  representant 0;
  foreign '';
  foreign_prop '';
  position 0;
};

prop deleted 
{ 
  type CO_INTEGER;
  default 0;
  params "READONLY=1;HIDDEN=1";
  representant 0;
  foreign '';
  foreign_prop '';
  position 0;
}; 


prop inherits_acl
{
  type CO_INTEGER;
  default 1;
  params 'HIDDEN=1;READONLY=1';
  representant 0;
  foreign '';
  foreign_prop '';
  position 50;
};


include_c "../coffice/mod_coffice.h";

	method showFormAssociation
	{
		doc "this method shows form for creating/browsing associations of two classes";
		doc "Returns: nothing";

		id_permission 7 ;
		sec_type 1 ;

		param par_area {type CO_STRING; optional 1; default "par_area=cnx->par_area;";}; param par_class {type CO_STRING; optional 1; default "par_class=cnx->par_class;";}; param par_id { type CO_INTEGER; }; 

		param column_first_class
		{
			type CO_STRING;
			optional 1;
			default "column_first_class=NULL";
			doc "this is the name of the column containing reference to the first class";
		};
 
		param report_first_class
		{
			type CO_STRING;
			optional 1;
			default "report_first_class=NULL";
			doc "this is the name of the report for selecting records from the first class";
		};
 
		param column_second_class
		{
			type CO_STRING;
			optional 1;
			default "column_second_class=NULL";
			doc "this is the name of the column containing reference to the second class";
		};
 
		param report_second_class
		{
			type CO_STRING;
			optional 1;
			default "report_second_class=NULL";
			doc "this is the name of the report for selecting records from the second class";
		};
 
		declare language_c
		{
			C "const char* filename;";	
			C "const char* root_path;";	
			C "const char* prop_foreign1;";	
			C "const char* prop_foreign2;";	
		};  
 
		body language_c
		{
			C 
			%%

            __SQL_GET_STRING( prop_foreign1, "SELECT prop_foreign FROM co_%s_meta_prop WHERE
 class_name='%s' and prop_name='%s'", par_area, par_class, column_first_class)

            __SQL_GET_STRING( prop_foreign2, "SELECT prop_foreign FROM co_%s_meta_prop WHERE
 class_name='%s' and prop_name='%s'", par_area, par_class, column_second_class)

			//cou_putsHTML("<FRAMESET rows=\"50,50%,*\">");			
			root_path = cou_getCORootPath( cnx );
			filename = ap_psprintf(p, "%s/generic_association/showFormAssociation.asp", root_path);
			__PUT_ASP_FROM_FILE(filename)

			%%
			;
		};
	}; // end of showFormAssociation

	method showFormMenu
	{
		doc "this method creates object and sets ACLs taken from acl_class, also sets props as given in create_params";

		id_permission 7 ;
		sec_type 1 ;

		param par_area {type CO_STRING; optional 1; default "par_area=cnx->par_area;";}; param par_class {type CO_STRING; optional 1; default "par_class=cnx->par_class;";}; param par_id { type CO_INTEGER; }; 

		param menu_name
		{
			type CO_STRING;
			optional 1;
			default "menu_name=\"default\"";
			doc "this is the name of the menu ('default' by default)";
		};
 
		param menu_type
		{
			type CO_STRING;
			optional 1;
			default "menu_type=\"multi\"";
			doc "this is the type (single, multi) of the menu ('multi' by default)";
		};

		declare language_c
		{
			C "const char* filename;";	
			C "const char* root_path;";	
		};  
 
		body language_c
		{
			C 
			%%

			root_path = cou_getCORootPath( cnx );
			filename = ap_psprintf(p, "%s/menu/showMenu.asp", root_path);
			__PUT_ASP_FROM_FILE(filename)
	
			%%
			;
		};
	}; // end of showFormAssociation


	method insertAssociations
	{
		doc "this method creates object and sets ACLs taken from acl_class, also sets props as given in create_params";
		doc "Returns: ???";

		id_permission 10 ;
		sec_type 1 ;

		param par_area {type CO_STRING; optional 1; default "par_area=cnx->par_area;";}; param par_class {type CO_STRING; optional 1; default "par_class=cnx->par_class;";}; param par_id { type CO_INTEGER; };  param callback {type CO_STRING; optional 1; default "callback=ap_pstrdup(p,\"\");";}; 

		param ids_first_class
		{
			type CO_ARRAY_OF_STRINGS;
			optional 1;
			default "ids_first_class=NULL";
			doc "this is array of ids belonging to the first class";
		};
 
		param prop_first_class
		{
			type CO_STRING;
			optional 1;
			default "prop_first_class=NULL";
			doc "this is name of the property storing ids belonging to the first class";
		};
 
		param ids_second_class
		{
			type CO_ARRAY_OF_STRINGS;
			optional 1;
			default "ids_second_class=NULL";
			doc "this is array of ids belonging to the second class";
		};
 
		param prop_second_class
		{
			type CO_STRING;
			optional 1;
			default "prop_second_class=NULL";
			doc "this is name of the property storing ids belonging to the second class";
		};
 
		declare language_c
		{
			C "int NIds1=0, NIds2=0;";	
			C "int i,j;";
			C "int id_new;";
			C "const char *str_id1, *str_id2;";	
			C "co_array_of_pointers * create_params;";
			C 'co_recordset * inserted_corec;';
		};  
 
		body language_c
		{
			C 
			%%
			inserted_corec = cor_CreateEmpty(cnx);
			NIds1 = coa_GetElementCount(cnx, ids_first_class);
			NIds2 = coa_GetElementCount(cnx, ids_second_class);
			for(i=0; i<NIds1; i++)
			{
				str_id1 = coa_GetStringElement(cnx, ids_first_class, i);
				for(j=0; j<NIds2; j++)
				{
					str_id2 = coa_GetStringElement(cnx, ids_second_class, j);
					// create new record, then select it and add to result
					create_params = coa_Create( cnx );
					coa_AppendElement( cnx, create_params, prop_first_class);
					coa_AppendElement( cnx, create_params, str_id1);
					coa_AppendElement( cnx, create_params, prop_second_class);
					coa_AppendElement( cnx, create_params, str_id2);
					@co_lcall(par_area, par_class, "createAndSet", 						par_area=>par_area, par_class=>par_class, par_id=>par_id, 						create_params=>create_params, callback=>'""');
					__GET_RETURNED_INTEGER(id_new);
					__CREATE_QUERY("SELECT * FROM co_%s_%s WHERE id=%d", 
						par_area, par_class, id_new)
					__SQL_GET_RESULT
					cor_AppendRecordset(cnx, inserted_corec, corec);
					__CLEAR_RESULT
				}
			}
			__CREATE_JS_FROM(inserted_corec)
			__RETURN_RECORDSET(inserted_corec)
			%%
			;
		};
	}; // end of insertAssociations


};  // end of class generic_association
