#include "init_file_names.t"
#include "defines.t"      

file __INIT_MENU_GENERIC_CATALOG()
{

/* this is default menu that we can see on generic forms */
class menu
{
  area sys;
  full_control root;
  full_control user;

  remove_old "name='default#single@generic_catalog' and class_name='generic_catalog'";
  p name       {val		"default#single@generic_catalog";};
  p id_parent  {getByName 	menu {f root;};};
  p class_name {val		generic_catalog;};
};

/*this is menu for left side on catalog form */
class menu
{
  area sys;
  full_control root;
  full_control user;

  remove_old "name='left#catalog@generic_catalog' and class_name='generic_catalog'";

  p name       {val		"left#catalog@generic_catalog";};
  p id_parent  {getByName 	menu {f root;};};
  p class_name {val		generic_catalog;};
};

/* this is menu for right side on catalog form */
class menu
{
  area sys;
  full_control root;
  full_control user;

  remove_old "name='right#catalog@generic_catalog' and class_name='generic_catalog'";

  p name       {val		"right#catalog@generic_catalog";};
  p id_parent  {getByName 	menu {f root;};};
  p class_name {val		generic_catalog;};
};


/* menu_delete */
class js_code
{
  area sys;

  full_control root;
  full_control user;

   p code
   {
      val
      %%
       var par_area = COServer.getAreaName();
       
       ap_write("open_url('/co/asp/" + par_area + "/catalog?deleteItem"+
             "&active_area="+par_area+
             "&active_class="+context.active_class+
             "&active_item=" +context.active_item+
             "&active_path=" +context.active_path+
             "&version="+context.version+
             "&debug_level=0');");
      %%
      ;
    };
};    

class  menu_action
{
  area sys;

  full_control root;
  full_control user;

  remove_old "name='generic_catalog_delete'";

   p name {val "generic_catalog_delete";};
   p id_js_code {recent js_code;};
};

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_class;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_item;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_path;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val version;};
  p id_menu_action {recent menu_action;};
};  


class menu
{
  area sys;

  full_control root;
  full_control user;

  remove_old "name='delete' and class_name='generic_catalog'";

  p name {val delete;};
  p class_name {val generic_catalog;};
  p id_parent { getByName menu {f "default#single@generic_catalog";};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_DELETE ;};
  p display_name {val delete;};
  p menu_position {val 200; };
};

class menu
{
  area sys;
  full_control root;
  full_control user;

  p name {val delete;};
  p class_name {val generic_catalog;};
  p id_parent { getByName menu {f "right#catalog@generic_catalog";};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_DELETE ;};
  p menu_position {val 200; };
};

/* end of delete */

/* menu_new */
class js_code
{
   area sys;

   full_control root;
   full_control user;

   p code
   {
      val
      %%
        var area = COServer.getAreaName();
        ap_write(
          "open_url('/co/asp/"+area+"/catalog?createItem" + 
                 "&active_area=" + area +
                 "&active_class="+ context.active_class+
                 "&active_item="+ context.active_item +
                 "&active_path=" +context.active_path +
                 "&debug_level=0');");
      %%
      ;
    };
};   

class  menu_action
{
  area sys;

  full_control root;
  full_control user;

  remove_old "name='generic_catalog_new'";

   p name {val generic_catalog_new;};
   p id_js_code {recent js_code;};
};

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_class;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_item;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_path;};
  p id_menu_action {recent menu_action;};
};  


/* this is menu_item for default */
class menu
{
  area sys;
  full_control root;
  full_control user;

  remove_old "name='new' and class_name='generic_catalog'";

  p name {val new;};
  p class_name {val generic_catalog;};
  p id_parent { getByName menu {f "default#single@generic_catalog";};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_INSERT_CHILD ;};
  p display_name {val new;};
  p menu_position {val 100; };
};

class menu
{
  area sys;
  full_control root;
  full_control user;

  p name {val new;};
  p class_name {val generic_catalog;};
  p id_parent { getByName menu {f "left#catalog@generic_catalog";};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_INSERT_CHILD ;};
  p menu_position {val 100; };
};
/* end of new */

/* menu_trash */
class js_code
{
   area sys;

   full_control root;
   full_control user;

   p code
   {
      val
      %%
        var par_area = COServer.getAreaName();
        ap_write("open_url('/co/asp/" + par_area + "/catalog?trash" + 
                 "&active_area="+ par_area+
                 "&active_class="+ context.active_class+
                 "&active_item="+context.active_item+
                 "&active_path=" +context.active_path+
                 "&debug_level=0');");
      %%
      ;
    };
};   

class  menu_action
{
  area sys;

  full_control root;
  full_control user;

  remove_old "name='generic_catalog_trash'";

   p name {val generic_catalog_trash;};
   p id_js_code {recent js_code;};
};

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_class;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_item;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_path;};
  p id_menu_action {recent menu_action;};
};  


/* this is menu_item for default */
class menu
{
  area sys;
  full_control root;
  full_control user;

  remove_old "name='trash' and class_name='generic_catalog'";

  p name {val trash;};
  p class_name {val generic_catalog;};
  p id_parent { getByName menu {f "default#single@generic_catalog";};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_UNDELETE ;};
  p display_name {val trash;};
  p menu_position {val 300; };
};

class menu
{
  area sys;
  full_control root;
  full_control user;

  p name {val trash;};
  p class_name {val generic_catalog;};
  p id_parent { getByName menu {f "left#catalog@generic_catalog";};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_UNDELETE ;};
  p menu_position {val 300; };
};
/* end of trash */

/* menu_go! */
class js_code
{
   area sys;

   full_control root;
   full_control user;

   p code
   {
      val
      %%
        var par_area = COServer.getAreaName();

        // we read items data
        var meta = new class_meta_class(par_area);
	var cat = eval("new class_" + context.active_class + "('" + par_area + "');"); 
        var rs =  cat.getItemData(context.active_item);
	var type_class_name = rs.getValueByName(0, "type_class_name");

        if (type_class_name!="attachment")
	{
	 // we take default form for items class
         var default_form = meta.getDefaultFormByName( -1 , type_class_name);
 
         // we ask to open window with default form
         ap_write("open_url('/co/html/" + par_area+ "/" + type_class_name+"?" + default_form +
                 "&par_area="+ par_area + 
                 "&par_class="+ type_class_name+
                 "&par_id="+rs.getValueByName(0,"id_item")+
                 "&active_path=" +context.active_path+
                 "&debug_level=0');");
        }
        else
	{
	 //ap_write("open_url('/co/attachment/data/"+
	 //           rs.getValueByName(0,"id_item")+"/"+
	 //	   rs.getValueByName(0,"name")+"');");
	 ap_write("open_url('/co/html/sys/attachment?getFile&par_id="+
	             rs.getValueByName(0,"id_item")+"');");
	}
      %%
      ;
    };
};

class  menu_action
{
  area sys;

  full_control root;
  full_control user;

  remove_old "name='generic_catalog_go'";

   p name {val generic_catalog_go;};
   p id_js_code {recent js_code;};
};

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_class;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_item;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_path;};
  p id_menu_action {recent menu_action;};
};  


/* this is menu_item for default */
class menu
{
  area sys;
  full_control root;
  full_control user;

  remove_old "name='go' and class_name='generic_catalog'";

  p name {val go;};
  p class_name {val generic_catalog;};
  p id_parent { getByName menu {f "default#single@generic_catalog";};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_GET ;};
  p display_name {val go;};
  p menu_position {val 100; };
};

class menu
{
  area sys;
  full_control root;
  full_control user;

  p name {val go;};
  p class_name {val generic_catalog;};
  p id_parent { getByName menu {f "right#catalog@generic_catalog";};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_GET ;};
  p menu_position {val 100; };
};
/* end of go! */


/* menu_permissions */
class js_code
{
  area sys;

  full_control root;
  full_control user;

   p code
   {
      val
      %%
       var par_area = COServer.getAreaName();
 
       ap_write("open_url('/co/asp/" + par_area + "/catalog?setACL"+
             "&active_area="+par_area+
             "&active_class="+context.active_class+
             "&active_item=" +context.active_item+
             "&active_path=" +context.active_path+
             "&version="+context.version+
             "&debug_level=0');");
      %%
      ;
    };
};    

class  menu_action
{
  area sys;

  full_control root;
  full_control user;

  remove_old "name='generic_catalog_permissions'";

   p name {val generic_catalog_permissions;};
   p id_js_code {recent js_code;};
};

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_class;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_item;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_path;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val version;};
  p id_menu_action {recent menu_action;};
};  


class menu
{
  area sys;
  full_control root;
  full_control user;

  remove_old "name='permissions' and class_name='generic_catalog'";

  p name {val permissions;};
  p class_name {val generic_catalog;};
  p id_parent { getByName menu {f "default#single@generic_catalog";};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_CHANGE_ACL ;};
  p display_name {val permissions;};
  p menu_position {val 300; };
};

class menu
{
  area sys;
  full_control root;
  full_control user;

  p name {val permissions;};
  p class_name {val generic_catalog;};
  p id_parent { getByName menu {f "right#catalog@generic_catalog";};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_CHANGE_ACL ;};
  p menu_position {val 300; };
};
/* end of permission */


/* menu edit */
class js_code
{
   area sys;

   full_control root;
   full_control user;

   p code
   {
      val
      %%
        var par_area = COServer.getAreaName();

        ap_write("open_url('/co/html/" + par_area+ "/" + context.active_class +"?showForm"  +
                 "&par_area=" + par_area + 
                 "&par_class="+ context.active_class +
                 "&par_id="   + context.active_item +
                 "&active_path=" +context.active_path+
                 "&deep_level=1" + 
                 "&debug_level=0');");
     %%
      ;
    };
};

class  menu_action
{
  area sys;

  full_control root;
  full_control user;

  remove_old "name='generic_catalog_edit'";

   p name {val generic_catalog_edit;};
   p id_js_code {recent js_code;};
};

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_class;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_item;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_path;};
  p id_menu_action {recent menu_action;};
};  


/* this is menu_item for default */
class menu
{
  area sys;
  full_control root;
  full_control user;

  remove_old "name='edit' and class_name='generic_catalog'";

  p name {val edit;};
  p class_name {val generic_catalog;};
  p id_parent { getByName menu {f "default#single@generic_catalog";};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_GET ;};
  p display_name {val edit;};
  p menu_position {val 100; };
};

class menu
{
  area sys;
  full_control root;
  full_control user;

  p name {val edit;};
  p class_name {val generic_catalog;};
  p id_parent { getByName menu {f "right#catalog@generic_catalog";};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_GET ;};
  p menu_position {val 100; };
};
/* end of edit */

/* menu cut */
class js_code
{
   area sys;

   full_control root;
   full_control user;

   p code
   {
      val
      %%
        var par_area = COServer.getAreaName();
		var cat = eval( "new class_"+context.active_class+"('"+par_area+"')");
		cat.cut(context.active_item);
      %%
      ;
    };
};

class  menu_action
{
  area sys;

  full_control root;
  full_control user;

  remove_old "name='generic_catalog_cut'";

   p name {val generic_catalog_cut;};
   p id_js_code {recent js_code;};
};

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_class;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_item;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_path;};
  p id_menu_action {recent menu_action;};
};  


/* this is menu_item for default */
class menu
{
  area sys;
  full_control root;
  full_control user;

  remove_old "name='cut' and class_name='generic_catalog'";

  p name {val cut;};
  p class_name {val generic_catalog;};
  p id_parent { getByName menu {f "default#single@generic_catalog";};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_GET ;};
  p display_name {val cut;};
  p menu_position {val 100; };
};

class menu
{
  area sys;
  full_control root;
  full_control user;

  p name {val cut;};
  p class_name {val generic_catalog;};
  p id_parent { getByName menu {f "right#catalog@generic_catalog";};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_DELETE ;};
  p menu_position {val 100; };
};

/* end of cut */

/* menu paste */
class js_code
{
   area sys;

   full_control root;
   full_control user;

   p code
   {
      val
      %%
        var par_area = COServer.getAreaName();
		var cat = eval( "new class_"+context.active_class+"('"+par_area+"')");
		cat.paste(context.active_item);
      %%
      ;
    };
};

class  menu_action
{
  area sys;

  full_control root;
  full_control user;

  remove_old "name='generic_catalog_paste'";

   p name {val generic_catalog_paste;};
   p id_js_code {recent js_code;};
};

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_class;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_item;};
  p id_menu_action {recent menu_action;};
};  

class menu_action_param
{
  area sys;

  full_control root;
  full_control user;

  p param_name {val active_path;};
  p id_menu_action {recent menu_action;};
};  


/* this is menu_item for default */
class menu
{
  area sys;
  full_control root;
  full_control user;

  remove_old "name='paste' and class_name='generic_catalog'";

  p name {val paste;};
  p class_name {val generic_catalog;};
  p id_parent { getByName menu {f "default#single@generic_catalog";};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_INSERT_CHILD ;};
  p display_name {val paste;};
  p menu_position {val 100; };
};

class menu
{
  area sys;
  full_control root;
  full_control user;

  p name {val paste;};
  p class_name {val generic_catalog;};
  p id_parent { getByName menu {f "left#catalog@generic_catalog";};};
  p id_menu_action {recent menu_action;};
  p id_permission {val __PERMISSION_INSERT_CHILD ;};
  p menu_position {val 100; };
};
/* end of cut */

}; // end file menu_generic_catalog
