#include "types.t"
#include "defines.t"

#define __PARAMS_HEADER2 __PARAMS_HEADER
    
class meta_class
{
	area sys
	{
		force_sec_type 1;
	};

#include "check_acl.t"
   
   index inac
   {
     unique 0;
     column area;
     column class_name;
   };

   container_class '';
   container_column_name '';

#include "generic_acl_props.t"    

   prop area
   {
     type CO_STRING;
     default "'sys'";
     params '';
     representant 1;
     foreign '';
     foreign_prop '';
     position 200;
   };

   prop class_name
   {
     type CO_STRING;
     default "''";
     params '';
     representant 1;
     foreign '';
     foreign_prop '';
     position 200;
   };

   prop id_inherits_from
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 300;
   };
   
   prop inherits_area
   {
     type CO_STRING;
     default "''";
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 300;
   };
   
   prop inherits_from
   {
     type CO_STRING;
     default "''";
     params '';
     representant 0;
     foreign 'meta_class';
     foreign_prop 'class_name';
     position 300;
   };

   prop inheritance_path
   {
#if 0
     f_body
     %%
     @ "select inheritance_path(select * from cov_${name_area}_${name_class} where id=\$1.id_inherits_from)||'|'||(\$1.area)||'_'||(\$1.class_name);"
     %%
     ;
#endif
     type CO_STRING;
     default "''";
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 300;
   };

   prop container_class
   {
     type CO_STRING;
     default "''";
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 400;

   };

   prop container_column_name
   {
     type CO_STRING;
     default "''";
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 500;

   };

   prop default_form
   {
     type CO_STRING;
     default "''";
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 600;

   };
 
   prop sec_type
   {
     type CO_INTEGER;
     default 0;
     params 'VALUES=new Array(0,1);';
     representant 0;
     foreign '';
     foreign_prop '';
     position 700;
   };


   prop force_sec_type
   {
     type CO_INTEGER;
     default 0;
     params 'VALUES=new Array(0,1);';
     representant 0;
     foreign '';
     foreign_prop '';
     position 800;
   };

 
   prop reloid
   {
     type CO_INDEX;
     default 0;
     params 'READONLY=1;';
     representant 0;
     foreign '';
     foreign_prop '';
     position 900;
   };

   prop name
	{
  f_body
  %%
     SELECT ($1.area)||''_''||($1.class_name);
  %%
  ;
		type CO_STRING;
		default "''";
		params '';
		representant 0;
		foreign '';
		foreign_prop '';
		position 400;
		group_path '';
   };

   index in1
   {
    unique 0;
    column class_name;
   };
 
   inherits generic_acl;
   
	uses generic;

  method getDefaultFormByName
  {
     id_permission __PERMISSION_SELECT;
     sec_type __METHOD_SEC_TYPE_CLASS;
   
     __PARAMS_HEADER_WITH_CALLBACK
     param class_name {type CO_STRING;};
     
     declare language_c
     {
        C 'char * default_form;';
        C 'char * inherits_from;';
     };

     body language_c
     {
         C 
         %%
	  default_form = ap_pstrdup(p, "");
          inherits_from = ap_pstrdup(p, class_name);
	  if( !(strlen(inherits_from) > 2) ) cou_error( cnx, "class_name shorter thar 3 chars");
	  corec = NULL;
          while ( (strlen(default_form) == 0) && (strlen(inherits_from) > 2) )
          {
             __CREATE_QUERY("SELECT default_form, inherits_from FROM co_%s_meta_class WHERE class_name='%s'" , par_area, inherits_from);
             __SQL_GET_RESULT
             if(cor_GetTupleCount(cnx, corec) != 1)
             {
                cou_sendMessageX(cnx, ap_psprintf(p, "getDefaultFormByName: zla nazwa klasy bazowa: '%s' obecna: '%s'", class_name, inherits_from), CO_MSG_FORCE);
                cou_setReturnValue(cnx, ap_pstrdup(p, ""), CO_STRING);
                return -1;
             }; 
             default_form =  cor_GetCopyOfValue(cnx, corec, 0,0);
             inherits_from = cor_GetCopyOfValue(cnx, corec, 0,1);
          };
          cou_sendMessageX(cnx, ap_psprintf(p, "SEND_DATA: %d", cnx->send_data), CO_MSG_DEBUG);
          __CREATE_JS
          cou_setReturnValue(cnx, default_form, CO_STRING);
         %%
         ; 
      };  
								    
  };

  method getFullPathByClassName
  {
     doc 
        %%
This method returns names for all classes that given class inherits from -- full path. Names are separated by '|'
Typical result: generic|generic_acl|catalog|  
        %%
     {
         pl 
         %%
Ta metoda zwraca nazwy wszystkich klas, z ktorych dziedziczy dana klasa -- pelna sciezka. Nazwy sa rozdzielane przez znak 'I'
Przykladowy wynik: generic|generic_acl|catalog|
         %%
         ;  
     };

     id_permission __PERMISSION_SELECT;
     sec_type __METHOD_SEC_TYPE_CLASS;
   
     __PARAMS_HEADER_WITH_CALLBACK
     param area_name {type CO_STRING; optional 1; default 'area_name="sys";';};
     param class_name {type CO_STRING;};
     
     declare language_c
     {
        C 'char * path;';
     };

     body language_c
     {
         C 
         %%
       path = ap_pstrdup(p, "");
       __SQL_GET_STRING(path,"SELECT getpathx('%s','meta_class', 'class_name', 'inherits_from', 'class_name','|','generic', '%s')",
                                            par_area, class_name)
       cou_setReturnValue(cnx, path, CO_STRING);
       __CREATE_JS_FROM_STRING(path);
        %%
         ; 
      };
								    
  };

  method getFullInheritancePath
  {
     doc
        %%
This method returns {area}_{class_name} for all classes from path of inheritenca of given class -- full path. Names are separated by '|'
Example result: sys_generic_view|sys_generic|sys_generic_catalog|sys_catalog|
        %%
     {
         pl 
         %%
Ta metoda zwraca nazwy wszystkich klas, ze cieki dziedziczenia danej klasy -- pelna sciezka. Nazwy sa rozdzielane przez znak '|'
Przykladowy wynik: sys_generic_view|sys_generic|sys_generic_catalog|sys_catalog|
         %%
         ;
     };

     id_permission __PERMISSION_SELECT;
     sec_type __METHOD_SEC_TYPE_CLASS;
   
     __PARAMS_HEADER_WITH_CALLBACK
#if 0
     param area_name {type CO_STRING; optional 1; default 'area_name="sys";';};
     param class_name {type CO_STRING;};
#endif     
     declare language_c
     {
        C 'char * path;';
     };

     body language_c
     {
         C 
         %%
       path = ap_pstrdup(p, "");
       __SQL_GET_STRING(path,"SELECT co_sys_meta_class_calculate_inheritance_path('%s','%s')", par_area, par_class)
       cou_setReturnValue(cnx, path, CO_STRING);
       __CREATE_JS_FROM_STRING(path);
        %%
         ; 
      };  
								    
  };

  method getFullIdPathById
  {
     doc 
        %%
This method returns ids for all classes from the path of inheritance of a given class. Numbers are separated by '|'
        %%
     {
         pl 
         %%
Ta metoda zwraca identyfikatory na sciece dziedziczenia danej klasy. Separatorem jest znak '|'.
         %%
         ;
     };

     id_permission __PERMISSION_SELECT;
     sec_type __METHOD_SEC_TYPE_CLASS;

     __PARAMS_HEADER_WITH_CALLBACK
     param id_meta_class {type CO_INTEGER;};

     declare language_c
     {
        C 'char * path;';
     };

     body language_c
     {
         C 
         %%
       path = ap_pstrdup(p, "");
       __SQL_GET_STRING(path,"SELECT getpathx('%s','meta_class', 'id', 'id_inherits_from', 'id','|',0,%d)",
                                            par_area, id_meta_class)
       cou_setReturnValue(cnx, path, CO_STRING);
       __CREATE_JS_FROM_STRING(path);
        %%
         ;
      };
								    
  };

	method refreshView
	{
		doc "This method refreshes the cov_ ... view for this class "
		{
			pl "Ta metoda kasuje i tworzy nowy widok cov_ .. dla aktualnej klasy ";
		};
	

		id_permission __PERMISSION_UPDATE;
		sec_type __METHOD_SEC_TYPE_OBJECT;
   
		__PARAMS_HEADER
     
		declare language_c
		{
			C 'char * class_name;';
			C 'int NProps;';
			C 'int i;';
		};

		body language_c
		{
			C 
			%%
			// getting class_name
			@co_getProp(par_area, par_class, par_id, '"class_name"');
			class_name = get_str;

			// getting props, we have to do this before we delete view
			@co_filterByProp(par_area, '"meta_prop"', '"*"', '"class_name"', class_name);
			NProps = cor_GetTupleCount(cnx, corec);

			// executing query
			__CREATE_QUERY("DROP VIEW cov_%s_%s", par_area, class_name)
			__SQL_EXEC

			__CREATE_QUERY("CREATE VIEW cov_%s_%s AS SELECT * ", par_area, class_name)


			for(i=0; i<NProps; i++)
			{
				char * f_body    = cor_GetValueByName(cnx, corec, i, "f_body");
				char * prop_name = cor_GetValueByName(cnx, corec, i, "prop_name");
				if(strlen(f_body)>0)
				{
					__APPEND_TO_QUERY(" , cof_%s_%s_%s(c) AS %s ", par_area, class_name, prop_name, prop_name)
				}
			}
			__APPEND_TO_QUERY(" FROM  co_%s_%s AS c ", par_area, class_name)
			__SQL_EXEC
 
			//granting rights to nobody
			__CREATE_QUERY(" GRANT ALL ON  cov_%s_%s TO nobody ", par_area, class_name)
			__SQL_EXEC
			%%
			; 
		};  
								    
	}; // method refreshView




   function_sql add
   {
     params "(text,text,text,text,text,text)";
     returns int;

// we treat this like perl code to substitute ${name_area} with current area name     
// that is why we have to escpae $ in declaration block
     
     S
     %%
     @"
      DECLARE
       _area ALIAS FOR \$1;
       _class_name ALIAS FOR \$2;
       _inherit_area ALIAS FOR \$3;
       _inherit_class_name ALIAS FOR \$4;
       _container_class alias for \$5;
       _container_column alias for \$6;
      BEGIN
       delete from co_${name_area}_meta_class where class_name = _class_name and area = _area;
       insert into co_${name_area}_meta_class(area, class_name, inherits_area, inherits_from, container_class, container_column_name)
	   values(_area, _class_name, _inherit_area, _inherit_class_name, _container_class, _container_column);

       RETURN 1;
      END;
      "
     %%
     ;
   };     

   function_sql calculate_id_inherits_from
   {
     params "(text,text)";
     returns int;

// we treat this like perl code to substitute ${name_area} with current area name     
// that is why we have to escpae $ in declaration block
// OPTIMIZE!!!     

     S
     %%
     @"
      DECLARE
       _area ALIAS FOR \$1;
       _class_name ALIAS FOR \$2;
       _id_meta_class int;
       _id_inherit_meta_class int;
      BEGIN
       select id into _id_meta_class from co_${name_area}_meta_class where area = _area and class_name = _class_name;
       select M2.id into _id_inherit_meta_class
        from co_${name_area}_meta_class M1, co_${name_area}_meta_class M2
	where M2.area = M1.inherits_area and M2.class_name = M1.inherits_from
	and M1.id = _id_meta_class;
       update co_${name_area}_meta_class
        set id_inherits_from = _id_inherit_meta_class
        where id = _id_meta_class;
       RETURN 1;
      END;
      "
     %%
     ;
   };     

   function_sql calculate_inheritance_path
   {
     params "(text,text)";
     returns text;

// we treat this like perl code to substitute ${name_area} with current area name
// that is why we have to escpae $ in declaration block
// OPTIMIZE!!!

     S
     %%
     @"
      DECLARE
       _area ALIAS FOR \$1;
       _class_name ALIAS FOR \$2;
       _inheritance_path text;
       _partial_path text;
      BEGIN
       _inheritance_path:=_area||''_''||_class_name||''|'';
       IF _inheritance_path ISNULL THEN
         RETURN '''';
       END IF;
       select co_sys_meta_class_calculate_inheritance_path(inherits_area,inherits_from) into _partial_path
         from co_sys_meta_class where area=_area and class_name=_class_name and id_inherits_from IS NOT NULL;
       IF _partial_path ISNULL THEN
         _partial_path:='''';
       END IF;
       _inheritance_path:=_partial_path||_inheritance_path;
--       update co_sys_meta_class set inheritance_path=_inheritance_path;
       RETURN _inheritance_path;
      END;
      "
     %%
     ;
   };     


};
      