#include "types.t"
#include "defines.t"

#define __PARAMS_HEADER2 __PARAMS_HEADER
    
class meta_prop
{
   area sys
   {
       force_sec_type 1;
   };

#include "check_acl.t"

   inherits generic_acl;
   
   container_class 'meta_class';
   container_column_name 'class_name';

#include "generic_acl_props.t" 


  index in1 
  { 
    unique 0; 
    column class_name; 
    column prop_representant; 
  }; 

  index inac
  { 
    unique 0; 
    column area;
    column class_name; 
  }; 



	prop prop_name
	{
		type CO_STRING;
		default "''";
		params '';
		representant 100;
		foreign '';
		foreign_prop '';
		position 200;
		group_path '';
   };
 
	prop state
	{
		type CO_STRING;
		default "'NEW'";
		params '';
		representant 100;
		foreign '';
		foreign_prop '';
		position 250;
		group_path '';
   };
 
	prop area
	{
		type CO_STRING;
		default "'sys'";
		params '';
		representant 1;
		foreign '';
		foreign_prop '';
		position 300;
		group_path '';
	};
   
	prop class_name
	{
		type CO_STRING;
		default "''";
		params '';
		representant 1;
		foreign 'meta_class';
		foreign_prop 'class_name';
		position 300;
		group_path '';
	};
   
	prop prop_representant
	{
		type CO_INTEGER;
		default "''";
		params '';
		representant 0;
		foreign '';
		foreign_prop '';
		position 400;
		group_path '';
	};
   
	prop prop_foreign_area
	{
		type CO_STRING;
		default "'sys'";
		params '';
		representant 0;
		foreign '';
		foreign_prop '';
		position 500;
		group_path '';
       };

    	prop prop_foreign
	{
		type CO_STRING;
		default "''";
		params '';
		representant 0;
		foreign '';
		foreign_prop '';
		position 500;
		group_path '';
        };
                  
	prop prop_foreign_prop
	{
		type CO_STRING;
		default "''";
		params '';
		representant 0;
		foreign '';
		foreign_prop '';
		position 600;
		group_path '';
	};

	prop prop_foreign_dynamic
	{
		type CO_INTEGER;
		default 0;
		params '';
		representant 0;
		foreign '';
		foreign_prop '';
		position 600;
		group_path '/00';
	};

	prop prop_foreign_dynamic_classes
	{
		type CO_STRING;
		default "''";
		params '';
		representant 0;
		foreign '';
		foreign_prop '';
		position 600;
		group_path '/10';
	};

	prop prop_foreign_dynamic_prop
	{
		type CO_STRING;
		default "''";
		params '';
		representant 0;
		foreign '';
		foreign_prop '';
		position 600;
		group_path '/20';
	};

	prop prop_position
	{
		type CO_INTEGER;
		default "''";
		params '';
		representant 0;
		foreign '';
		foreign_prop '';
		position 700;
		group_path '';
	};

	prop prop_type
	{
		type CO_STRING;
		default "''";
		params '';
		representant 0;
		foreign '';
		foreign_prop '';
		position 800;
		group_path '';
	};

	prop prop_params
	{
		type CO_STRING;
		default "''";
		params 'ROWS=10; COLS=30';
		representant 0;
		foreign '';
		foreign_prop '';
		position 900;
		group_path '';
	};

	prop prop_group
	{
		type CO_STRING;
		default "''";
		params '';
		representant 0;
		foreign '';
		foreign_prop '';
		position 1000;
		group_path '';
	};

	prop prop_group_parent
	{
		type CO_STRING;
		default "''";
		params '';
		representant 0;
		foreign '';
		foreign_prop '';
		position 1100;
		group_path '';
	};

	prop prop_group_path
	{
		type CO_STRING;
		default "''";
		params '';
		representant 0;
		foreign '';
		foreign_prop '';
		position 1200;
		group_path '';
	};

	prop f_body
	{
		type CO_STRING;
		default "''";
		params '';
		representant 0;
		foreign '';
		foreign_prop '';
		position 1300;
		group_path '';
	};

	prop attoid
	{
		type CO_INDEX;
		default 0;
		params 'READONLY=1;';
		representant 0;
		foreign '';
		foreign_prop '';
		position 1400;
		group_path '';
	};

	prop name
	{
  f_body
  %%
     SELECT class_name($1) || ''.'' || prop_name($1);
  %%
  ;
		type CO_STRING;
		default "'NEW'";
		params '';
		representant 0;
		foreign '';
		foreign_prop '';
		position 400;
		group_path '';
   };

	uses generic;
	uses meta_class;

	method commitChange
	{
		doc "This method commits all changes done on this property to database"
		{
			pl "Ta metoda wprowadza wszystkie zrobione na tym prop zmiany do bazy danych";
		};

		id_permission __PERMISSION_UPDATE;
		sec_type __METHOD_SEC_TYPE_OBJECT;
   
		__PARAMS_HEADER
     
		declare language_c
		{
			C 'char * state;';
			C 'char * sql_type;';
			C 'char * prop_type;';
			C 'char * prop_name;';
			C 'int id_class;';
		};

		body language_c
		{
			C 
			%%
			// reading state
			@co_call(par_area, par_class, "get", par_area=>par_area, par_class=>par_class, par_id=>par_id);
			__GET_RETURNED_RECORDSET(corec)
			state = cor_GetValueByName(cnx, corec, 0, "state");
			prop_name = cor_GetValueByName(cnx, corec, 0, "prop_name");
			prop_type = cor_GetValueByName(cnx, corec, 0, "prop_type");

			// this is new prop
			if(strcmp(state, "NEW")==0)
			{
				//changing state to INSYNC
				@co_call(par_area, par_class, "update", par_area=>par_area, par_class=>par_class, par_id=>par_id, par_prop=>'"state"', new_value=>'"INSYNC"', version=>-1);
				// getting sql_type
				@co_getPropByName(par_area, '"meta_type"', prop_type, '"sql_type"');
				sql_type = get_str;

				// adding column to table
				__CREATE_QUERY("ALTER TABLE co_%s_%s ADD COLUMN %s %s", par_area, par_class, prop_name, sql_type)
				__SQL_EXEC

				// getting class id
				@co_filterByProp(par_area,  '"meta_class"', '"id"', '"class_name"', par_class);
				id_class = atoi(cor_GetValue(cnx, corec, 0, 0));

				// refreshing view for this class
				@co_call(par_area, '"meta_class"', "refreshView", par_area=>par_area, par_class=>'"meta_class"', par_id=>id_class);
			}
			%%
			; 
		};  

	}; // method commitChange


};
