#include "types.t"
#include "defines.t"

#define __PARAMS_HEADER2 __PARAMS_HEADER

class meta_vtable
{
   area sys
   {
       force_sec_type 1;
   };

#include "check_acl.t"

   container_class 'meta_class';
   container_column_name 'class_name';

#include "generic_acl_props.t"

  index inacm
  { 
    unique 0; 
    column area;
    column class_name; 
    column method_name; 
  };

   prop area
   {
     type CO_STRING;
     default "'sys'";
     params '';
     representant 1;
     foreign 'meta_class';
     foreign_prop 'class_name';
     position 200;
   };

   prop class_name
   {
     type CO_STRING;
     default "''";
     params '';
     representant 1;
     foreign 'meta_class';
     foreign_prop 'class_name';
     position 200;
   };

   prop method_name
   {
     type CO_STRING;
     default "''";
     params '';
     representant 100;
     foreign '';
     foreign_prop '';
     position 200;
   };
   
   prop target_area
   {
     type CO_STRING;
     default "'sys'";
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 200;
   };

   prop target_class_name
   {
     type CO_STRING;
     default "''";
     params '';
     representant 0;
     foreign 'meta_class';
     foreign_prop 'name';
     position 200;
   };

   prop id_permission
   {
     type CO_INTEGER;
     default "''";
     params '';
     representant 0;
     foreign 'permission';
     foreign_prop 'id';
     position 200;
   };

   prop id_onbefore_script
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign 'js_code';
     foreign_prop 'id';
     position 200;
   };

   prop id_onbefore_method
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign 'meta_method';
     foreign_prop 'id';
     position 200;
   };

   prop id_script
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign 'js_code';
     foreign_prop 'id';
     position 200;
   };

   prop id_onafter_script
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign 'js_code';
     foreign_prop 'id';
     position 200;
   };

   prop id_onafter_method
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign 'meta_method';
     foreign_prop 'id';
     position 200;
   };

   prop profiled
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 210;
   };

   prop sec_type
   {
     type CO_INTEGER;
     default 0;
     params 'VALUES=new Array(0, 1);';
     representant 0;
     foreign '';
     foreign_prop '';
     position 220;
   };

   prop force_sec_type
   {
     type CO_INTEGER;
     default 0;
     params 'VALUES=new Array(0, 1);';
     representant 0;
     foreign '';
     foreign_prop '';
     position 220;
   };

	inherits generic_acl;

	uses generic;
	uses generic_acl;
 
	method updateTarget
	{
		doc "This method updates target_class_name prop and other props in meta_vtable. It is called by meta_method.commitChange "
		{
			pl "Ta metoda poprawia target_class_name i inne pola meta_vtable. Jest wywoywana przez meta_method.commitChange";
		};

		id_permission __PERMISSION_UPDATE;
		sec_type __METHOD_SEC_TYPE_CLASS;
   
		__PARAMS_HEADER

		param class_name
		{
			doc "class_name of method that we modify"
			{
				pl "nazwa klasy modyfikowanej metody";
			};
			type CO_STRING;
		};
	
		param method_name
		{
			doc "name of method that we modify"
			{
				pl "nazwa modyfikowanej metody";
			};
			type CO_STRING;
		};

		param target_class
		{
			doc "proposed target_class for method that we modify"
			{
				pl "proponowana nazwa klasy docelowej dla modyfikowanej metody";
			};
			type CO_STRING;
		};

		param id_permission
		{
			doc "id_permission"
			{
				pl "id_permission";
			};
			type CO_INTEGER;
		};
	
		param sec_type
		{
			doc ""
			{
				pl "";
			};
			type CO_INTEGER;
		};
					
    	param force_sec_type
		{
			doc ""
			{
				pl "";
			};
			type CO_INTEGER;
		};
	
		declare language_c
		{
			C 'co_array_of_pointers * get_class_names    = coa_Create(cnx);';
			C 'co_array_of_pointers * get_prop_names     = coa_Create(cnx);';
			C 'co_array_of_pointers * filter_class_names = coa_Create(cnx);';
			C 'co_array_of_pointers * filter_prop_names  = coa_Create(cnx);';
			C 'co_array_of_pointers * filter_operators   = coa_Create(cnx);';
			C 'co_array_of_pointers * filter_values      = coa_Create(cnx);';
			C 'co_array_of_pointers * create_params      = coa_Create(cnx);';
			C 'int NTuples = 0;';
			C 'int NClasses = 0;';
			C 'int i = 0;';
			C 'char * str_id_permission;';
			C 'char * str_sec_type;';
			C 'char * str_force_sec_type;';
			C 'int id_class = 0;';
			C 'int do_for_sub_class = 0;';
		};
 
		body language_c
		{
			C 
			%%
			__SEND_MESG_DEBUG("Entering updateTarget for class_name:'%s' method_name:'%s' ", class_name, method_name)

			//getting info from vtable
			coa_AppendElement(cnx, get_class_names, "meta_vtable");
			coa_AppendElement(cnx, get_prop_names,  "id");

			coa_AppendElement(cnx, get_class_names, "meta_vtable");
			coa_AppendElement(cnx, get_prop_names,  "target_class_name");

			coa_AppendElement(cnx, filter_class_names, "meta_vtable");
			coa_AppendElement(cnx, filter_prop_names,  "class_name");
			coa_AppendElement(cnx, filter_operators,   "=");
			coa_AppendCopyOfElement(cnx, filter_values,      class_name);

			coa_AppendElement(cnx, filter_class_names, "meta_vtable");
			coa_AppendElement(cnx, filter_prop_names,  "method_name");
			coa_AppendElement(cnx, filter_operators,   "=");
			coa_AppendCopyOfElement(cnx, filter_values,      method_name);


			@co_lcall(par_area,'"meta_vtable"',"selectX",par_area=>par_area,par_class=>'"meta_vtable"',par_id=>-1, \
                  get_class_names=>get_class_names,get_prop_names=>get_prop_names, \
                  filter_class_names=>filter_class_names,filter_prop_names=>filter_prop_names, \
                  filter_operators=>filter_operators, filter_values=>filter_values);

			__GET_RETURNED_RECORDSET(corec)

			__SEND_MESG_DEBUG("we have corec")

			NTuples = cor_GetTupleCount(cnx, corec);
			__ASSERT(NTuples<2,"HARD CORE ERROR - more than one record in meta_vtable for class:%s, method:%s",class_name, method_name)

			__SEND_MESG_DEBUG("we have NTuples: %d", NTuples)
			
			if(NTuples==0)
			{
				// super-new

				//1. insert into meta_vtable
				//TODO: check whether these values are valid
				coa_AppendElement(cnx, create_params, "method_name");
				coa_AppendCopyOfElement(cnx, create_params, method_name);

				coa_AppendElement(cnx, create_params, "class_name");
				coa_AppendCopyOfElement(cnx, create_params, class_name);

				coa_AppendElement(cnx, create_params, "target_class_name");
				coa_AppendCopyOfElement(cnx, create_params, target_class);

				str_id_permission = ap_psprintf(p, "%d", id_permission);
				coa_AppendElement(cnx, create_params, "id_permission");
				coa_AppendCopyOfElement(cnx, create_params, str_id_permission);

				str_sec_type = ap_psprintf(p, "%d", sec_type);
				coa_AppendElement(cnx, create_params, "sec_type");
				coa_AppendCopyOfElement(cnx, create_params, str_sec_type);

				str_force_sec_type = ap_psprintf(p, "%d", force_sec_type);
				coa_AppendElement(cnx, create_params, "force_sec_type");
				coa_AppendCopyOfElement(cnx, create_params, str_force_sec_type);

				@co_lcall(par_area,'"meta_vtable"',"createAndSetWithACL",par_area=>par_area,par_class=>'"meta_vtable"',par_id=>-1,create_params=>create_params);
				
				do_for_sub_class=1;
			}
			if(NTuples==1)
			{
				//overloaded
				// first we check if we implement this method on this level	
				char * target_class_name = cor_GetValueByName(cnx, corec, 0, "target_class_name");
				if(strcmp(target_class_name, class_name)!=0)
				{
					// if this inherited method then we change target class
					//TODO: what about sec, force_sec and others? 

					int id_vtable = atoi(cor_GetValueByName(cnx, corec, 0, "id"));
					@co_call(par_area, '"meta_vtable"', "update",par_area=>par_area, par_class=>'"meta_vtable"',par_id=>id_vtable,par_prop=>'"target_class_name"',new_value=>target_class);
					do_for_sub_class=1;
				}

			}

			if(do_for_sub_class==1)
			{

				// we call updateTarget for all sub-classes
				__SEND_MESG_DEBUG("getting id for class_name:%s", class_name)
				@co_filterByProp(par_area,  '"meta_class"', '"id"', '"class_name"', class_name);
				NClasses = cor_GetTupleCount(cnx,corec);
				__ASSERT(NClasses==1, "More then one or 0 records in meta_class for class_name:%s", class_name)
				id_class = atoi(cor_GetValue(cnx, corec, 0, 0));

				@co_lcall(par_area,'"meta_class"', "getRelatedData", par_area=>par_area,par_class=>'"meta_class"',par_id=>id_class, related_class=>'"meta_class"',related_prop=>'"inherits_from"');

				__SEND_MESG_DEBUG("related classes finished!")
				{
					co_recordset * corec2;
					co_array_of_pointers * sub_class_names;
					int NElems=0;

					// we implicitly clear corec!
					__GET_RETURNED_RECORDSET(corec2)

					__SEND_MESG_DEBUG("we have recordset")

					NClasses = cor_GetTupleCount(cnx, corec2);

					__SEND_MESG_DEBUG("Number of sub-classes:%d", NClasses)

					sub_class_names = cor_GetCopyOfColumnByName(cnx, corec2, "class_name");
					__ASSERT(sub_class_names!=NULL, "Error in getting array of sub-class names")

					NElems = coa_GetElementCount(cnx, sub_class_names);
					__ASSERT(NElems>-1, "Error in getting number of elements for array of sub-class names")

					__SEND_MESG_DEBUG("we have column with sub_class_names NEl: %d", NElems);

					__ASSERT(NElems==NClasses, "HARD CORE ERROR number of elements not equal to number of tuples after cor_GetCopyOfColumnByName")

					for(i=0; i<NClasses; i++)
					{
						char * sub_class_name;

						__SEND_MESG_DEBUG("Getting sub_class_name i:%d NClasses:%d", i, NClasses)

						sub_class_name = coa_GetStringElement(cnx, sub_class_names, i);

						__SEND_MESG_DEBUG("Calling updateTarget for class_name:'%s' method_name:'%s' i:%d NClasses:%d", sub_class_name, method_name, i, NClasses)

						@co_call(par_area,'"meta_vtable"',"updateTarget", par_area=>par_area, par_class=>'"meta_vtable"', par_id=>-1, class_name=>sub_class_name, \
					          method_name=>method_name, target_class=>target_class, id_permission=>id_permission, sec_type=>sec_type, \
					          force_sec_type=>force_sec_type);

						__SEND_MESG_DEBUG("After call updateTarget for class_name:'%s' method_name:'%s' i:%d NClasses:%d", sub_class_name, method_name, i, NClasses)

					}
				}
				__SEND_MESG_DEBUG("Finished updateTarget for class_name:'%s' method_name:'%s' ", class_name, method_name)

			}

			%%
			; 
		};  

	}; // method updateTarget


  
   function_sql generate
   {
     doc "generates vtable entries for given class";
     params '(text, text)';
     returns int;

// we put this as perl code!     
   S
   %%
   @"
     DECLARE
       _area ALIAS FOR \$1;
       _class_name ALIAS FOR \$2;
       _current_area text;
       _current_class text;
       _h_class text;
       _force_sec_type int;
     BEGIN
      
        SELECT force_sec_type INTO _force_sec_type FROM co_${name_area}_meta_class WHERE area = _area and class_name = _class_name;
        delete from co_${name_area}_meta_vtable where area = _area and class_name = _class_name;
	  
        _current_area := _area;
        _current_class := _class_name;
       WHILE NOT(_current_class ISNULL) AND char_length(_current_class::text) > 0 LOOP
	        
         INSERT INTO co_${name_area}_meta_vtable(area, class_name, method_name, target_area, target_class_name, id_permission, 
                                                 id_onbefore_script, id_onbefore_method, id_script, id_onafter_script, id_onafter_method, profiled, sec_type, force_sec_type)
         SELECT _area, _class_name, M.method_name, _current_area, _current_class, M.id_permission, 
                M.id_onbefore_script, M.id_onbefore_method, M.id_script, M.id_onafter_script, M.id_onafter_method, M.profiled, M.sec_type, _force_sec_type
            FROM co_${name_area}_meta_method M, co_${name_area}_meta_class C
            WHERE M.id_meta_class = C.id AND
	    C.area = _current_area AND
	    C.class_name = _current_class AND NOT
               M.method_name IN
               (
                SELECT method_name FROM co_${name_area}_meta_vtable  
                WHERE _area = area AND _class_name = class_name
               );
            
         _h_class := _current_class;
	 select inherits_from into _current_class
	 from co_${name_area}_meta_class
	 where area = _current_area and class_name = _current_class;
	 select inherits_area into _current_area
	 from co_${name_area}_meta_class
	 where area = _current_area and class_name = _h_class;

       END LOOP;
					    
       RETURN 1;
    END;  
    "
   %%
   ;
   };


   function_sql test_acl_dupa
   {
     doc "generates vtable entries for given class";
     params '@ "(co_${name_area}_meta_vtable, int, int)"';
     returns int;
	language 'sql';

// we put this as perl code!     
   S
   %%
   @"
  SELECT
    CASE WHEN \$1.sec_type=1 OR \$1.force_sec_type=1
      THEN
        co_sys_acl_class_check(\\'$name_area\\', \$1.class_name, \$1.id_permission, \$3)
      ELSE
        co_sys_acl_check(\\'$name_area\\', \$1.class_name, \$2, \$1.id_permission, \$3)
      END; 
     "
   %%
   ;
   };


};
